---
title: Create a custom asset
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[Custom Pages](https://developers.cloudflare.com/api/go/resources/custom_pages)

[Assets](https://developers.cloudflare.com/api/go/resources/custom_pages/subresources/assets)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Create a custom asset

client.CustomPages.Assets.New(ctx, params) (\*[AssetNewResponse](<https://developers.cloudflare.com/api/go/resources/custom_pages#(resource)%20custom_pages.assets%20%3E%20(model)%20AssetNewResponse%20%3E%20(schema)>), error)

POST/{accounts\_or\_zones}/{account\_or\_zone\_id}/custom\_pages/assets

Creates a custom asset for an account or zone.

##### Security

API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**`X-Auth-Email: user@example.com`

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**`X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194`

##### ParametersExpand Collapse

<details>

<summary>

params AssetNewParams

</summary>

Description param.Field\[string]

Body param: A short description of the custom asset.

<a href="#(resource)%20custom_pages.assets%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20description">Link to this property</a>

Name param.Field\[string]

Body param: The unique name of the custom asset. Can only contain letters (A-Z, a-z), numbers (0-9), and underscores (\_).

minLength1

<a href="#(resource)%20custom_pages.assets%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20name">Link to this property</a>

URL param.Field\[string]

Body param: The URL where the asset content is fetched from.

formaturi

<a href="#(resource)%20custom_pages.assets%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20url">Link to this property</a>

AccountID param.Field\[string]Optional

Path param: The Account ID to use for this endpoint. Mutually exclusive with the Zone ID.

<a href="#(resource)%20custom_pages.assets%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20account_id">Link to this property</a>

ZoneID param.Field\[string]Optional

Path param: The Zone ID to use for this endpoint. Mutually exclusive with the Account ID.

<a href="#(resource)%20custom_pages.assets%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20zone_id">Link to this property</a>

</details>

[Link to this property](<#(resource)%20custom_pages.assets%20%3E%20(method)%20create%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type AssetNewResponse struct{…}

</summary>

Description stringOptional

A short description of the custom asset.

<a href="#(resource)%20custom_pages.assets%20%3E%20(model)%20AssetNewResponse%20%3E%20(schema)%20%3E%20(property)%20description">Link to this property</a>

LastUpdated TimeOptional

formatdate-time

<a href="#(resource)%20custom_pages.assets%20%3E%20(model)%20AssetNewResponse%20%3E%20(schema)%20%3E%20(property)%20last_updated">Link to this property</a>

Name stringOptional

The unique name of the custom asset. Can only contain letters (A-Z, a-z), numbers (0-9), and underscores (\_).

minLength1

<a href="#(resource)%20custom_pages.assets%20%3E%20(model)%20AssetNewResponse%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

SizeBytes int64Optional

The size of the asset content in bytes.

<a href="#(resource)%20custom_pages.assets%20%3E%20(model)%20AssetNewResponse%20%3E%20(schema)%20%3E%20(property)%20size_bytes">Link to this property</a>

URL stringOptional

The URL where the asset content is fetched from.

formaturi

<a href="#(resource)%20custom_pages.assets%20%3E%20(model)%20AssetNewResponse%20%3E%20(schema)%20%3E%20(property)%20url">Link to this property</a>

</details>

[Link to this property](<#(resource)%20custom_pages.assets%20%3E%20(model)%20AssetNewResponse%20%3E%20(schema)>)

### Create a custom asset

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/custom_pages"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIKey("144c9defac04969c7bfad8efaa8ea194"),
    option.WithAPIEmail("user@example.com"),
  )
  asset, err := client.CustomPages.Assets.New(context.TODO(), custom_pages.AssetNewParams{
    Description: cloudflare.F("Custom 500 error page"),
    Name: cloudflare.F("my_custom_error_page"),
    URL: cloudflare.F("https://example.com/error.html"),
  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", asset.Description)
}
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "description": "Custom 500 error page",
    "last_updated": "2014-01-01T05:20:00.12345Z",
    "name": "my_custom_error_page",
    "size_bytes": 1024,
    "url": "https://example.com/error.html"
  }
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "description": "Custom 500 error page",
    "last_updated": "2014-01-01T05:20:00.12345Z",
    "name": "my_custom_error_page",
    "size_bytes": 1024,
    "url": "https://example.com/error.html"
  }
}
```